#!/usr/bin/python
#  Copyright (c) 1999-2017, Parallels International GmbH. All rights reserved.
#
#  This file is part of OpenVZ. OpenVZ is free software; you can redistribute
#  it and/or modify it under the terms of the GNU General Public License as
#  published by the Free Software Foundation; either version 2 of the License,
#  or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#  02110-1301, USA.
#
#  Our contact details: Parallels International GmbH, Vordergasse 59, 8200
#  Schaffhausen, Switzerland.

import sys
libexecdir = "/usr/libexec"
if sys.path.count(libexecdir) == 0:
    sys.path.append(libexecdir)
from vzfirewall import fdirect, FIREWALLD_DIRECT, dparms, is_firewalld_running, check_args
from subprocess32 import call, check_call

try:
    from firewall.core.io.direct import Direct
except:
    # Firewall not installed.
    sys.exit(0)

check_args()

RULE_ARGS = ["-i", "venet0", "-j", "DROP"]

with fdirect() as d:
    for ip in ["ipv4", "ipv6"]:
        for priority in (0, 10):
            # Do not add INPUT_direct venet with zero prio
            if sys.argv[1] == "add" and priority == 0:
                continue
            d.process_rule(ip, "filter", "INPUT_direct", priority, RULE_ARGS)
    del(d)

is_firewalld_running()

for ip in ["ipv4", "ipv6"]:
    for priority in (0, 10):
        # Do not add INPUT_direct venet with zero prio
        if sys.argv[1] == "add" and priority == 0:
            continue
        call(dparms + [ip, "filter", "INPUT_direct", "%i" % priority] + RULE_ARGS)
